Index: src/analysis_bonds.cpp
===================================================================
--- src/analysis_bonds.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/analysis_bonds.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -26,9 +26,7 @@
   Mean = 0.;
 
-  atom *Walker = mol->start;
   int AtomCount = 0;
-  while (Walker->next != mol->end) {
-    Walker = Walker->next;
-    const int count = Walker->ListOfBonds.size();
+  for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+    const int count = (*iter)->ListOfBonds.size();
     if (Max < count)
       Max = count;
@@ -58,10 +56,8 @@
 
   int AtomNo = 0;
-  atom *Walker = mol->start;
-  while (Walker->next != mol->end) {
-    Walker = Walker->next;
-    if (Walker->type == type1)
-      for (BondList::const_iterator BondRunner = Walker->ListOfBonds.begin(); BondRunner != Walker->ListOfBonds.end(); BondRunner++)
-        if ((*BondRunner)->GetOtherAtom(Walker)->type == type2) {
+  for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+    if ((*iter)->type == type1)
+      for (BondList::const_iterator BondRunner = (*iter)->ListOfBonds.begin(); BondRunner != (*iter)->ListOfBonds.end(); BondRunner++)
+        if ((*BondRunner)->GetOtherAtom((*iter))->type == type2) {
           const double distance = (*BondRunner)->GetDistanceSquared();
           if (Min > distance)
@@ -126,6 +122,4 @@
 int CountHydrogenBridgeBonds(MoleculeListClass *molecules, const element * InterfaceElement = NULL)
 {
-  atom *Walker = NULL;
-  atom *Runner = NULL;
   int count = 0;
   int OtherHydrogens = 0;
@@ -133,15 +127,13 @@
   bool InterfaceFlag = false;
   bool OtherHydrogenFlag = true;
-  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin();MolWalker != molecules->ListOfMolecules.end(); MolWalker++) {
-    Walker = (*MolWalker)->start;
-    while (Walker->next != (*MolWalker)->end) {
-      Walker = Walker->next;
-      for (MoleculeList::const_iterator MolRunner = molecules->ListOfMolecules.begin();MolRunner != molecules->ListOfMolecules.end(); MolRunner++) {
-        Runner = (*MolRunner)->start;
-        while (Runner->next != (*MolRunner)->end) {
-          Runner = Runner->next;
-          if ((Walker->type->Z  == 8) && (Runner->type->Z  == 8)) {
+  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin();MolWalker != molecules->ListOfMolecules.end(); ++MolWalker) {
+    molecule::iterator Walker = (*MolWalker)->begin();
+    for(;Walker!=(*MolWalker)->end();++Walker){
+      for (MoleculeList::const_iterator MolRunner = molecules->ListOfMolecules.begin();MolRunner != molecules->ListOfMolecules.end(); ++MolRunner) {
+        molecule::iterator Runner = (*MolRunner)->begin();
+        for(;Runner!=(*MolRunner)->end();++Runner){
+          if (((*Walker)->type->Z  == 8) && ((*Runner)->type->Z  == 8)) {
             // check distance
-            const double distance = Runner->x.DistanceSquared(Walker->x);
+            const double distance = (*Runner)->x.DistanceSquared((*Walker)->x);
             if ((distance > MYEPSILON) && (distance < HBRIDGEDISTANCE*HBRIDGEDISTANCE)) { // distance >0 means  different atoms
               // on other atom(Runner) we check for bond to interface element and
@@ -151,9 +143,9 @@
               OtherHydrogens = 0;
               InterfaceFlag = (InterfaceElement == NULL);
-              for (BondList::const_iterator BondRunner = Runner->ListOfBonds.begin(); BondRunner != Runner->ListOfBonds.end(); BondRunner++) {
-                atom * const OtherAtom = (*BondRunner)->GetOtherAtom(Runner);
+              for (BondList::const_iterator BondRunner = (*Runner)->ListOfBonds.begin(); BondRunner != (*Runner)->ListOfBonds.end(); BondRunner++) {
+                atom * const OtherAtom = (*BondRunner)->GetOtherAtom(*Runner);
                 // if hydrogen, check angle to be greater(!) than 30 degrees
                 if (OtherAtom->type->Z == 1) {
-                  const double angle = CalculateAngle(&OtherAtom->x, &Runner->x, &Walker->x);
+                  const double angle = CalculateAngle(&OtherAtom->x, &(*Runner)->x, &(*Walker)->x);
                   OtherHydrogenFlag = OtherHydrogenFlag && (angle > M_PI*(30./180.) + MYEPSILON);
                   Otherangle += angle;
@@ -176,10 +168,10 @@
               if (InterfaceFlag && OtherHydrogenFlag) {
                 // on this element (Walker) we check for bond to hydrogen, i.e. part of water molecule
-                for (BondList::const_iterator BondRunner = Walker->ListOfBonds.begin(); BondRunner != Walker->ListOfBonds.end(); BondRunner++) {
-                  atom * const OtherAtom = (*BondRunner)->GetOtherAtom(Walker);
+                for (BondList::const_iterator BondRunner = (*Walker)->ListOfBonds.begin(); BondRunner != (*Walker)->ListOfBonds.end(); BondRunner++) {
+                  atom * const OtherAtom = (*BondRunner)->GetOtherAtom(*Walker);
                   if (OtherAtom->type->Z == 1) {
                     // check angle
-                    if (CheckHydrogenBridgeBondAngle(Walker, OtherAtom, Runner)) {
-                      DoLog(1) && (Log() << Verbose(1) << Walker->Name << ", " << OtherAtom->Name << " and " << Runner->Name << " has a hydrogen bridge bond with distance " << sqrt(distance) << " and angle " << CalculateAngle(&OtherAtom->x, &Walker->x, &Runner->x)*(180./M_PI) << "." << endl);
+                    if (CheckHydrogenBridgeBondAngle(*Walker, OtherAtom, *Runner)) {
+                      DoLog(1) && (Log() << Verbose(1) << (*Walker)->getName() << ", " << OtherAtom->getName() << " and " << (*Runner)->getName() << " has a hydrogen bridge bond with distance " << sqrt(distance) << " and angle " << CalculateAngle(&OtherAtom->x, &(*Walker)->x, &(*Runner)->x)*(180./M_PI) << "." << endl);
                       count++;
                       break;
@@ -205,15 +197,14 @@
 int CountBondsOfTwo(MoleculeListClass * const molecules, const element * const first, const element * const second)
 {
-  atom *Walker = NULL;
   int count = 0;
 
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin();MolWalker != molecules->ListOfMolecules.end(); MolWalker++) {
-    Walker = (*MolWalker)->start;
-    while (Walker->next != (*MolWalker)->end) {
-      Walker = Walker->next;
-      if ((Walker->type == first) || (Walker->type == second)) {  // first element matches
-        for (BondList::const_iterator BondRunner = Walker->ListOfBonds.begin(); BondRunner != Walker->ListOfBonds.end(); BondRunner++) {
-          atom * const OtherAtom = (*BondRunner)->GetOtherAtom(Walker);
-          if (((OtherAtom->type == first) || (OtherAtom->type == second)) && (Walker->nr < OtherAtom->nr)) {
+    molecule::iterator Walker = (*MolWalker)->begin();
+    for(;Walker!=(*MolWalker)->end();++Walker){
+      atom * theAtom = *Walker;
+      if ((theAtom->type == first) || (theAtom->type == second)) {  // first element matches
+        for (BondList::const_iterator BondRunner = theAtom->ListOfBonds.begin(); BondRunner != theAtom->ListOfBonds.end(); BondRunner++) {
+          atom * const OtherAtom = (*BondRunner)->GetOtherAtom(theAtom);
+          if (((OtherAtom->type == first) || (OtherAtom->type == second)) && (theAtom->nr < OtherAtom->nr)) {
             count++;
             DoLog(1) && (Log() << Verbose(1) << first->name << "-" << second->name << " bond found between " << *Walker << " and " << *OtherAtom << "." << endl);
@@ -240,5 +231,4 @@
   bool MatchFlag[2];
   bool result = false;
-  atom *Walker = NULL;
   const element * ElementArray[2];
   ElementArray[0] = first;
@@ -246,12 +236,12 @@
 
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin();MolWalker != molecules->ListOfMolecules.end(); MolWalker++) {
-    Walker = (*MolWalker)->start;
-    while (Walker->next != (*MolWalker)->end) {
-      Walker = Walker->next;
-      if (Walker->type == second) {  // first element matches
+    molecule::iterator Walker = (*MolWalker)->begin();
+    for(;Walker!=(*MolWalker)->end();++Walker){
+      atom *theAtom = *Walker;
+      if (theAtom->type == second) {  // first element matches
         for (int i=0;i<2;i++)
           MatchFlag[i] = false;
-        for (BondList::const_iterator BondRunner = Walker->ListOfBonds.begin(); BondRunner != Walker->ListOfBonds.end(); BondRunner++) {
-          atom * const OtherAtom = (*BondRunner)->GetOtherAtom(Walker);
+        for (BondList::const_iterator BondRunner = theAtom->ListOfBonds.begin(); BondRunner != theAtom->ListOfBonds.end(); BondRunner++) {
+          atom * const OtherAtom = (*BondRunner)->GetOtherAtom(theAtom);
           for (int i=0;i<2;i++)
             if ((!MatchFlag[i]) && (OtherAtom->type == ElementArray[i])) {
Index: src/analysis_correlation.cpp
===================================================================
--- src/analysis_correlation.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/analysis_correlation.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -39,32 +39,33 @@
     return outmap;
   }
+  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
+    (*MolWalker)->doCountAtoms();
   outmap = new PairCorrelationMap;
-  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
+  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++){
     if ((*MolWalker)->ActiveFlag) {
       DoeLog(2) && (eLog()<< Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
-      atom *Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
-        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl);
-        if ((type1 == NULL) || (Walker->type == type1)) {
-          for (MoleculeList::const_iterator MolOtherWalker = MolWalker; MolOtherWalker != molecules->ListOfMolecules.end(); MolOtherWalker++)
+      eLog() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl;
+      for (molecule::const_iterator iter = (*MolWalker)->begin(); iter != (*MolWalker)->end(); ++iter) {
+        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << **iter << "." << endl);
+        if ((type1 == NULL) || ((*iter)->type == type1)) {
+          for (MoleculeList::const_iterator MolOtherWalker = MolWalker; MolOtherWalker != molecules->ListOfMolecules.end(); MolOtherWalker++){
             if ((*MolOtherWalker)->ActiveFlag) {
               DoLog(2) && (Log() << Verbose(2) << "Current other molecule is " << *MolOtherWalker << "." << endl);
-              atom *OtherWalker = (*MolOtherWalker)->start;
-              while (OtherWalker->next != (*MolOtherWalker)->end) { // only go up to Walker
-                OtherWalker = OtherWalker->next;
-                DoLog(3) && (Log() << Verbose(3) << "Current otheratom is " << *OtherWalker << "." << endl);
-                if (Walker->nr < OtherWalker->nr)
-                  if ((type2 == NULL) || (OtherWalker->type == type2)) {
-                    distance = Walker->node->PeriodicDistance(*OtherWalker->node, World::getInstance().getDomain());
-                    //Log() << Verbose(1) <<"Inserting " << *Walker << " and " << *OtherWalker << endl;
-                    outmap->insert ( pair<double, pair <atom *, atom*> > (distance, pair<atom *, atom*> (Walker, OtherWalker) ) );
+              for (molecule::const_iterator runner = (*MolOtherWalker)->begin(); runner != (*MolOtherWalker)->end(); ++runner) {
+                DoLog(3) && (Log() << Verbose(3) << "Current otheratom is " << **runner << "." << endl);
+                if ((*iter)->getId() < (*runner)->getId()){
+                  if ((type2 == NULL) || ((*runner)->type == type2)) {
+                    distance = (*iter)->node->PeriodicDistance(*(*runner)->node,  World::getInstance().getDomain());
+                    //Log() << Verbose(1) <<"Inserting " << *(*iter) << " and " << *(*runner) << endl;
+                    outmap->insert ( pair<double, pair <atom *, atom*> > (distance, pair<atom *, atom*> ((*iter), (*runner)) ) );
                   }
+                }
               }
+            }
           }
         }
       }
     }
-
+  }
   return outmap;
 };
@@ -95,4 +96,6 @@
     return outmap;
   }
+  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
+    (*MolWalker)->doCountAtoms();
   outmap = new PairCorrelationMap;
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
@@ -101,10 +104,8 @@
       double * FullInverseMatrix = InverseMatrix(FullMatrix);
       DoeLog(2) && (eLog()<< Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
-      atom *Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
-        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl);
-        if ((type1 == NULL) || (Walker->type == type1)) {
-          periodicX = *(Walker->node);
+      for (molecule::const_iterator iter = (*MolWalker)->begin(); iter != (*MolWalker)->end(); ++iter) {
+        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << **iter << "." << endl);
+        if ((type1 == NULL) || ((*iter)->type == type1)) {
+          periodicX = *(*iter)->node;
           periodicX.MatrixMultiplication(FullInverseMatrix);  // x now in [0,1)^3
           // go through every range in xyz and get distance
@@ -117,11 +118,9 @@
                   if ((*MolOtherWalker)->ActiveFlag) {
                     DoLog(2) && (Log() << Verbose(2) << "Current other molecule is " << *MolOtherWalker << "." << endl);
-                    atom *OtherWalker = (*MolOtherWalker)->start;
-                    while (OtherWalker->next != (*MolOtherWalker)->end) { // only go up to Walker
-                      OtherWalker = OtherWalker->next;
-                      DoLog(3) && (Log() << Verbose(3) << "Current otheratom is " << *OtherWalker << "." << endl);
-                      if (Walker->nr < OtherWalker->nr)
-                        if ((type2 == NULL) || (OtherWalker->type == type2)) {
-                          periodicOtherX = *(OtherWalker->node);
+                    for (molecule::const_iterator runner = (*MolOtherWalker)->begin(); runner != (*MolOtherWalker)->end(); ++runner) {
+                      DoLog(3) && (Log() << Verbose(3) << "Current otheratom is " << **runner << "." << endl);
+                      if ((*iter)->nr < (*runner)->nr)
+                        if ((type2 == NULL) || ((*runner)->type == type2)) {
+                          periodicOtherX = *(*runner)->node;
                           periodicOtherX.MatrixMultiplication(FullInverseMatrix);  // x now in [0,1)^3
                           // go through every range in xyz and get distance
@@ -132,6 +131,6 @@
                                 checkOtherX.MatrixMultiplication(FullMatrix);
                                 distance = checkX.distance(checkOtherX);
-                                //Log() << Verbose(1) <<"Inserting " << *Walker << " and " << *OtherWalker << endl;
-                                outmap->insert ( pair<double, pair <atom *, atom*> > (distance, pair<atom *, atom*> (Walker, OtherWalker) ) );
+                                //Log() << Verbose(1) <<"Inserting " << *(*iter) << " and " << *(*runner) << endl;
+                                outmap->insert ( pair<double, pair <atom *, atom*> > (distance, pair<atom *, atom*> ((*iter), (*runner)) ) );
                               }
                         }
@@ -141,6 +140,6 @@
         }
       }
-      Free(&FullMatrix);
-      Free(&FullInverseMatrix);
+      delete[](FullMatrix);
+      delete[](FullInverseMatrix);
     }
 
@@ -165,16 +164,16 @@
     return outmap;
   }
+  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
+    (*MolWalker)->doCountAtoms();
   outmap = new CorrelationToPointMap;
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
     if ((*MolWalker)->ActiveFlag) {
       DoLog(2) && (Log() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
-      atom *Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
-        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl);
-        if ((type == NULL) || (Walker->type == type)) {
-          distance = Walker->node->PeriodicDistance(*point, World::getInstance().getDomain());
+      for (molecule::const_iterator iter = (*MolWalker)->begin(); iter != (*MolWalker)->end(); ++iter) {
+        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << **iter << "." << endl);
+        if ((type == NULL) || ((*iter)->type == type)) {
+          distance = (*iter)->node->PeriodicDistance(*point, World::getInstance().getDomain());
           DoLog(4) && (Log() << Verbose(4) << "Current distance is " << distance << "." << endl);
-          outmap->insert ( pair<double, pair<atom *, const Vector*> >(distance, pair<atom *, const Vector*> (Walker, point) ) );
+          outmap->insert ( pair<double, pair<atom *, const Vector*> >(distance, pair<atom *, const Vector*> ((*iter), point) ) );
         }
       }
@@ -205,4 +204,6 @@
     return outmap;
   }
+  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
+    (*MolWalker)->doCountAtoms();
   outmap = new CorrelationToPointMap;
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
@@ -211,10 +212,8 @@
       double * FullInverseMatrix = InverseMatrix(FullMatrix);
       DoLog(2) && (Log() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
-      atom *Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
-        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl);
-        if ((type == NULL) || (Walker->type == type)) {
-          periodicX = *(Walker->node);
+      for (molecule::const_iterator iter = (*MolWalker)->begin(); iter != (*MolWalker)->end(); ++iter) {
+        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << **iter << "." << endl);
+        if ((type == NULL) || ((*iter)->type == type)) {
+          periodicX = *(*iter)->node;
           periodicX.MatrixMultiplication(FullInverseMatrix);  // x now in [0,1)^3
           // go through every range in xyz and get distance
@@ -226,10 +225,10 @@
                 distance = checkX.distance(*point);
                 DoLog(4) && (Log() << Verbose(4) << "Current distance is " << distance << "." << endl);
-                outmap->insert ( pair<double, pair<atom *, const Vector*> >(distance, pair<atom *, const Vector*> (Walker, point) ) );
+                outmap->insert ( pair<double, pair<atom *, const Vector*> >(distance, pair<atom *, const Vector*> (*iter, point) ) );
               }
         }
       }
-      Free(&FullMatrix);
-      Free(&FullInverseMatrix);
+      delete[](FullMatrix);
+      delete[](FullInverseMatrix);
     }
 
@@ -257,21 +256,24 @@
     return outmap;
   }
+  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
+    (*MolWalker)->doCountAtoms();
   outmap = new CorrelationToSurfaceMap;
   for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
     if ((*MolWalker)->ActiveFlag) {
       DoLog(1) && (Log() << Verbose(1) << "Current molecule is " << (*MolWalker)->name << "." << endl);
-      atom *Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
-        //Log() << Verbose(1) << "Current atom is " << *Walker << "." << endl;
-        if ((type == NULL) || (Walker->type == type)) {
-          TriangleIntersectionList Intersections(Walker->node,Surface,LC);
+      if ((*MolWalker)->empty())
+        DoLog(1) && (1) && (Log() << Verbose(1) << "\t is empty." << endl);
+      for (molecule::const_iterator iter = (*MolWalker)->begin(); iter != (*MolWalker)->end(); ++iter) {
+        DoLog(1) && (Log() << Verbose(1) << "\tCurrent atom is " << *(*iter) << "." << endl);
+        if ((type == NULL) || ((*iter)->type == type)) {
+          TriangleIntersectionList Intersections((*iter)->node,Surface,LC);
           distance = Intersections.GetSmallestDistance();
           triangle = Intersections.GetClosestTriangle();
-          outmap->insert ( pair<double, pair<atom *, BoundaryTriangleSet*> >(distance, pair<atom *, BoundaryTriangleSet*> (Walker, triangle) ) );
-        }
-      }
-    } else
+          outmap->insert ( pair<double, pair<atom *, BoundaryTriangleSet*> >(distance, pair<atom *, BoundaryTriangleSet*> ((*iter), triangle) ) );
+        }
+      }
+    } else {
       DoLog(1) && (Log() << Verbose(1) << "molecule " << (*MolWalker)->name << " is not active." << endl);
+    }
 
   return outmap;
@@ -306,4 +308,6 @@
     return outmap;
   }
+  for (MoleculeList::const_iterator MolWalker = molecules->ListOfMolecules.begin(); MolWalker != molecules->ListOfMolecules.end(); MolWalker++)
+    (*MolWalker)->doCountAtoms();
   outmap = new CorrelationToSurfaceMap;
   double ShortestDistance = 0.;
@@ -314,10 +318,8 @@
       double * FullInverseMatrix = InverseMatrix(FullMatrix);
       DoLog(2) && (Log() << Verbose(2) << "Current molecule is " << *MolWalker << "." << endl);
-      atom *Walker = (*MolWalker)->start;
-      while (Walker->next != (*MolWalker)->end) {
-        Walker = Walker->next;
-        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << *Walker << "." << endl);
-        if ((type == NULL) || (Walker->type == type)) {
-          periodicX = *(Walker->node);
+      for (molecule::const_iterator iter = (*MolWalker)->begin(); iter != (*MolWalker)->end(); ++iter) {
+        DoLog(3) && (Log() << Verbose(3) << "Current atom is " << **iter << "." << endl);
+        if ((type == NULL) || ((*iter)->type == type)) {
+          periodicX = *(*iter)->node;
           periodicX.MatrixMultiplication(FullInverseMatrix);  // x now in [0,1)^3
           // go through every range in xyz and get distance
@@ -337,10 +339,10 @@
               }
           // insert
-          outmap->insert ( pair<double, pair<atom *, BoundaryTriangleSet*> >(ShortestDistance, pair<atom *, BoundaryTriangleSet*> (Walker, ShortestTriangle) ) );
+          outmap->insert ( pair<double, pair<atom *, BoundaryTriangleSet*> >(ShortestDistance, pair<atom *, BoundaryTriangleSet*> (*iter, ShortestTriangle) ) );
           //Log() << Verbose(1) << "INFO: Inserting " << Walker << " with distance " << ShortestDistance << " to " << *ShortestTriangle << "." << endl;
         }
       }
-      Free(&FullMatrix);
-      Free(&FullInverseMatrix);
+      delete[](FullMatrix);
+      delete[](FullInverseMatrix);
     }
 
Index: src/analyzer.cpp
===================================================================
--- src/analyzer.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/analyzer.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -75,5 +75,5 @@
     return 1;
   } else {
-    dir = Malloc<char>(strlen(argv[2]) + 2, "main: *dir");
+    dir = new char[strlen(argv[2]) + 2];
     strcpy(dir, "/");
     strcat(dir, argv[2]);
@@ -82,5 +82,5 @@
   if (argc > 4) {
     DoLog(0) && (Log() << Verbose(0) << "Loading periodentafel." << endl);
-    periode = Malloc<periodentafel>(1, "main - periode");
+    periode = new periodentafel;
     periode->LoadPeriodentafel(argv[4]);
   }
@@ -558,5 +558,5 @@
   // ++++++++++++++++ exit ++++++++++++++++++++++++++++++++++
   delete(periode);
-  Free(&dir);
+  delete[](dir);
   DoLog(0) && (Log() << Verbose(0) << "done." << endl);
   return 0;
Index: src/atom.cpp
===================================================================
--- src/atom.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/atom.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -40,5 +40,5 @@
 
 atom *atom::clone(){
-  atom *res = new atom();
+  atom *res = new atom(this);
   res->previous=0;
   res->next=0;
@@ -59,5 +59,4 @@
 atom::~atom()
 {
-  unlink(this);
 };
 
@@ -270,6 +269,6 @@
 {
   if (ComponentNr != NULL)
-    Free(&ComponentNr);
-  ComponentNr = Malloc<int>(ListOfBonds.size()+1, "atom::InitComponentNumbers: *ComponentNr");
+    delete[](ComponentNr);
+  ComponentNr = new int[ListOfBonds.size()+1];
   for (int i=ListOfBonds.size()+1;i--;)
     ComponentNr[i] = -1;
Index: src/atom_bondedparticle.cpp
===================================================================
--- src/atom_bondedparticle.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/atom_bondedparticle.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -44,5 +44,5 @@
 void BondedParticle::OutputBondOfAtom() const
 {
-  DoLog(4) && (Log() << Verbose(4) << "Atom " << Name << "/" << nr << " with " << ListOfBonds.size() << " bonds: " << endl);
+  DoLog(4) && (Log() << Verbose(4) << "Atom " << getName() << "/" << nr << " with " << ListOfBonds.size() << " bonds: " << endl);
   int TotalDegree = 0;
   for (BondList::const_iterator Runner = ListOfBonds.begin(); Runner != ListOfBonds.end(); ++Runner) {
Index: src/atom_graphnode.cpp
===================================================================
--- src/atom_graphnode.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/atom_graphnode.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -27,5 +27,5 @@
 void GraphNode::OutputGraphInfo() const
 {
-  DoLog(2) && (Log() << Verbose(2) << "Atom " << Name << " is " << ((SeparationVertex) ? "a" : "not a") << " separation vertex, components are ");
+  DoLog(2) && (Log() << Verbose(2) << "Atom " << getName() << " is " << ((SeparationVertex) ? "a" : "not a") << " separation vertex, components are ");
   OutputComponentNumber();
   DoLog(3) && (Log() << Verbose(3) << " with Lowpoint " << LowpointNr << " and Graph Nr. " << GraphNr << "." << endl);
Index: src/atom_graphnodeinfo.cpp
===================================================================
--- src/atom_graphnodeinfo.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/atom_graphnodeinfo.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -17,4 +17,4 @@
 GraphNodeInfo::~GraphNodeInfo()
 {
-  Free<int>(&ComponentNr, "atom::~atom: *ComponentNr");
+  delete[](ComponentNr);
 };
Index: src/atom_particleinfo.cpp
===================================================================
--- src/atom_particleinfo.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/atom_particleinfo.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -11,13 +11,11 @@
 /** Constructor of ParticleInfo.
  */
-ParticleInfo::ParticleInfo() : nr(-1), Name(NULL) {};
+ParticleInfo::ParticleInfo() : nr(-1), name("Unknown") {
+};
 
 ParticleInfo::ParticleInfo(ParticleInfo *pointer) :
     nr(pointer->nr),
-    Name(pointer->Name)
-    {
-      if (Name == NULL)
-        Name = " ";
-    }
+    name(pointer->name)
+    {}
 
 
@@ -25,14 +23,17 @@
  */
 ParticleInfo::~ParticleInfo()
-{
-  Free(&Name);
-};
+{};
+
+const string& ParticleInfo::getName() const{
+  return name;
+}
+
+void ParticleInfo::setName(const string& _name){
+  name = _name;
+}
 
 ostream & operator << (ostream &ost, const ParticleInfo &a)
 {
-  if (a.Name == NULL)
-    ost << "[NULL]";
-  else
-    ost << "[" << a.Name << "|" << &a << "]";
+  ost << "[" << a.getName() << "|" << &a << "]";
   return ost;
 };
@@ -40,8 +41,5 @@
 ostream & ParticleInfo::operator << (ostream &ost) const
 {
-  if (Name == NULL)
-    ost << "[NULL]";
-  else
-    ost << "[" << Name << "|" << this << "]";
+  ost << "[" << name << "|" << this << "]";
   return ost;
 };
Index: src/atom_particleinfo.hpp
===================================================================
--- src/atom_particleinfo.hpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/atom_particleinfo.hpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -28,5 +28,4 @@
 public:
   int nr;       // index to easierly identify
-  char *Name;   // some name to reference to on output
 
   ParticleInfo();
@@ -34,7 +33,11 @@
   ~ParticleInfo();
 
+  const std::string& getName() const;
+  void setName(const std::string&);
+
   ostream & operator << (ostream &ost) const;
 
 private:
+  std::string name;   // some name to reference to on output
 };
 
Index: src/atom_trajectoryparticle.cpp
===================================================================
--- src/atom_trajectoryparticle.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/atom_trajectoryparticle.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -10,4 +10,5 @@
 #include "config.hpp"
 #include "element.hpp"
+#include "info.hpp"
 #include "log.hpp"
 #include "parser.hpp"
@@ -71,6 +72,7 @@
 void TrajectoryParticle::ResizeTrajectory(int MaxSteps)
 {
+  Info FunctionInfo(__func__);
   if (Trajectory.R.size() <= (unsigned int)(MaxSteps)) {
-    //Log() << Verbose(0) << "Increasing size for trajectory array of " << keyword << " to " << (MaxSteps+1) << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Increasing size for trajectory array of " << nr << " from " << Trajectory.R.size() << " to " << (MaxSteps+1) << "." << endl);
     Trajectory.R.resize(MaxSteps+1);
     Trajectory.U.resize(MaxSteps+1);
Index: src/bond.cpp
===================================================================
--- src/bond.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/bond.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -53,5 +53,5 @@
 ostream & operator << (ostream &ost, const bond &b)
 {
-  ost << "[" << b.leftatom->Name << " <" << b.BondDegree << "(H" << b.HydrogenBond << ")>" << b.rightatom->Name << "]";
+  ost << "[" << b.leftatom->getName() << " <" << b.BondDegree << "(H" << b.HydrogenBond << ")>" << b.rightatom->getName() << "]";
   return ost;
 };
Index: src/bondgraph.cpp
===================================================================
--- src/bondgraph.cpp	(revision b0e9c9b269a10c150b013b7fb592c9bf4771717b)
+++ src/bondgraph.cpp	(revision 4ed18b5079e3f4ea8a189543a78e279bb579b049)
@@ -88,7 +88,7 @@
 {
   Info FunctionInfo(__func__);
-bool status = true;
+  bool status = true;
 
-  if (mol->start->next == mol->end) // only construct if molecule is not empty
+  if (mol->empty()) // only construct if molecule is not empty
     return false;
 
@@ -124,9 +124,7 @@
   max_distance = 0.;
 
-  atom *Runner = mol->start;
-  while (Runner->next != mol->end) {
-    Runner = Runner->next;
-    if (Runner->type->CovalentRadius > max_distance)
-      max_distance = Runner->type->CovalentRadius;
+  for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+    if ((*iter)->type->CovalentRadius > max_distance)
+      max_distance = (*iter)->type->CovalentRadius;
   }
   max_distance *= 2.;
